App/App/Areas/User/Controllers/MenuController.cs
using System.Web.Mvc;
using App.Class;
using DataAccess.Dao;

namespace App.Areas.User.Controllers
{
    [ChildActionOnly]
    [Authorize(Roles = Role.User)]
    public class MenuController : Controller
    {
        // GET: User/Menu
        public ActionResult Index()
        {
            var vyukaUserDao = new VyukaUserDao();
            var vyukaUser = vyukaUserDao.GetByLogin(User.Identity.Name);
            return View("UserMenu", vyukaUser);
        }

        public ActionResult SidemenuProfil()
        {
            return PartialView();
        }

        public ActionResult SidemenuVocabulary()
        {
            return PartialView();
        }

        public ActionResult SidemenuText()
        {
            ViewBag.Categories = new ArticleCategoryDao().GetAll();
            return PartialView();
        }

        public ActionResult SidemenuTest()
        {
            ViewBag.Categories = new ArticleCategoryDao().GetAll();
            return PartialView();
        }

        public ActionResult SidemenuTestStart()
        {
            ViewBag.Categories = new ArticleCategoryDao().GetAll();
            return PartialView();
        }

        public ActionResult SidemenuTestSubmit()
        {
            ViewBag.Categories = new ArticleCategoryDao().GetAll();
            return PartialView();
        }

        public ActionResult SidemenuHome()
        {
            ViewBag.Categories = new ArticleCategoryDao().GetAll();
            return PartialView();
        }

        public ActionResult SidemenuMessage()
        {
            return PartialView();
        }
    }
}

App/App/Areas/User/Controllers/TestController.cs
using System;
using System.Web.Mvc;
using App.Class;
using DataAccess.Dao;
using DataAccess.Model;

namespace App.Areas.User.Controllers
{
    [Authorize(Roles = Role.User)]

public class TestController : Controller
    {
        // GET: User/Test
        public ActionResult Index(int id)
        {
            //načtení testu podle jeho Id
            Test test = new TestDao().GetById(id);
            //zobrazení dokončených testů konkrétního uživatele
            ViewBag.TestList =
                new TestFinishedDao().GetTestListByUserIdAndTestId(new VyukaUserDao().GetByLogin(User.Identity.Name).Id,
                    id);
            if (Request.IsAjaxRequest())
            {
                return PartialView(test);
            }
            return View(test);
        }

        public ActionResult StartTest(int id)
        {
            Test test = new TestDao().GetById(id);

            ViewBag.Nazev = new ArticleDao().GetArticleByTestId(id).Name;
            foreach (TestQuestions question in test.Questions)
            {
                foreach (TestAnswer answer in question.Answers)
                {
                    answer.IsCorrect = false;
                }
            }
            if (Request.IsAjaxRequest())
            {
                return PartialView(test);
            }
            return View(test);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult SubmitTest(Test testFilled)
        {
            //přiřazení id vyplněného testu 
            Test test = new TestDao().GetById(testFilled.Id);

            byte score = 0;
            byte maxScore = 0;

            for (int i = 0; i < test.Questions.Count; i++)
            {
                for (int j = 0; j < test.Questions[i].Answers.Count; j++)
                {
                    //ověření zda byla vyplněná odpověď správná
                    bool filledAnswer = testFilled.Questions[i].Answers[j].IsCorrect;
                    //ověření zda je testová otázka označená jako správná 
                    bool testAnswer = test.Questions[i].Answers[j].IsCorrect;
                    //ověření zda byla vybrána správná nebo špatná odpověď odpověď 
                    testFilled.Questions[i].Answers[j].WasCorrect = filledAnswer == testAnswer;

                    if (testAnswer && filledAnswer)
                    {
                        score++;
                    }
                    if(testAnswer)
                    {
                        maxScore++;
                    }
                }
            }

            ViewBag.Score = score;
            ViewBag.MaxScore = maxScore;
            ViewBag.Nazev = new ArticleDao().GetArticleByTestId(test.Id).Name;

            //vytvoření ukončeného testu podle uživatele
            new TestFinishedDao().Create(new TestFinished()
            {
                CompletingTest = DateTime.Now,
                MaxScore = maxScore,
                Score = score,
                TestId = test.Id,
                UserId = new VyukaUserDao().GetByLogin(User.Identity.Name).Id
            });

            if (Request.IsAjaxRequest())
            {
                return PartialView(testFilled);
            }
            return View(testFilled);
        }
    }
}

App/App/Areas/User/Controllers/TextController.cs
using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;
using App.Areas.User.Class;
using App.Class;
using DataAccess.Dao;
using DataAccess.Model;

namespace App.Areas.User.Controllers
{
    [Authorize(Roles = Role.User)]
    public class TextController : Controller
    {
        // GET: User/Text
        public ActionResult IndexTextUser()
        {
            ArticleDao articleDao = new ArticleDao();
            IList<Article> articles = articleDao.GetAll();
            IList<TestArticle> ta = new List<TestArticle>();

            foreach (Article a in articles)
            {
                if (a.TestId == 0)
                {
                    ta.Add(new TestArticle(){Article = a, Test = null});
                }
                else
                {
                    Test t = new TestDao().GetById(a.TestId);
                    ta.Add(new TestArticle(){Article = a, Test = t});
                }
            }

            if (Request.IsAjaxRequest())
            {
                return PartialView(ta);
            }
            return View(ta);
        }

        public ActionResult Detail(int id)
        {
            ArticleDao articleDao = new ArticleDao();
            Article a = articleDao.GetById(id);

            ViewBag.Categories = new ArticleCategoryDao().GetAll();

            if (Request.IsAjaxRequest())
            {
                return PartialView(a);
            }
            return View(a);
        }

        public ActionResult CategoryUser(int id)
        {
            IList<Article> article = new ArticleDao().GetArticlesInCategoryId(id);
            ViewBag.Categories = new ArticleCategoryDao().GetAll();
            IList<TestArticle> ta = new List<TestArticle>();

            foreach (Article a in article)
            {
                if (a.TestId == 0)
                {
                    ta.Add(new TestArticle() { Article = a, Test = null });
                }
                else
                {
                    Test t = new TestDao().GetById(a.TestId);
                    ta.Add(new TestArticle() { Article = a, Test = t });
                }
            }

            if (Request.IsAjaxRequest())
            {
                return PartialView("IndexTextUser", ta);
            }
            return View("IndexTextUser", ta);
        }

        public JsonResult SearchArticles(string query)
        {
            ArticleDao articleDao = new ArticleDao();
            IList<Article> articles = articleDao.SearchArticle(query);

            List<string> names = (from Article a in articles select a.Name).ToList();

            return Json(names, JsonRequestBehavior.AllowGet);
        }

        public ActionResult SearchTu(string phrase)
        {
            ArticleDao articleDao = new ArticleDao();
            ViewBag.Categories = new ArticleCategoryDao().GetAll();
            IList<Article> article = articleDao.SearchArticle(phrase);
            IList<TestArticle> ta = new List<TestArticle>();

            foreach (Article a in article)
            {
                if (a.TestId == 0)
                {
                    ta.Add(new TestArticle() { Article = a, Test = null });
                }
                else
                {
                    Test t = new TestDao().GetById(a.TestId);
                    ta.Add(new TestArticle() { Article = a, Test = t });
                }
            }

            if (Request.IsAjaxRequest())
            {
                return PartialView("IndexTextUser", ta);
            }
            return View("IndexTextUser", ta);
        }
    }
}

App/App/Areas/User/Views/Text/Detail.cshtml
@model DataAccess.Model.Article

@{Html.RenderAction("SidemenuText", "Menu");}

<div class="dashboard-wrapper">
    <div class="container-fluid dashboard-content">
        <h2>Detail článku @Model.Name</h2>
        <p>
            Autor: @Model.Author
        </p>

        @Html.Raw(Model.Description)

        @Ajax.ActionLink("Zpět na všechny články", "IndexTextUser", "Text", new AjaxOptions() { UpdateTargetId = "dynamicContent", InsertionMode = InsertionMode.Replace }, new { @class = "btn btn-outline-primary mb-3" })
        @if (Model.TestId != 0)
        {
            @Ajax.ActionLink("Zahájit test pro tuto kapitolu", "Index", "Test", new { id = Model.TestId }, new AjaxOptions() { UpdateTargetId = "dynamicContent", InsertionMode = InsertionMode.Replace }, new { @class = "btn btn-outline-primary mb-3" })
        }
    </div>
</div>

App/App/Areas/User/Views/Text/IndexTextUser.cshtml
@using App.Class
@model IList<App.Class.TestArticle>

@{Html.RenderAction("SidemenuText", "Menu");}

<div class="dashboard-wrapper">
    <div class="container-fluid dashboard-content">
        <div class="form-inline mt-2 mt-md-0">
            @using (Ajax.BeginForm("SearchTu", new AjaxOptions() { UpdateTargetId = "dynamicContent", InsertionMode = InsertionMode.Replace }))
            {
                <input class="form-control mr-sm-2" type="text" placeholder="Vyhledávání" aria-label="Vyhledejte frázi" id="searchBox" name="phrase">
                <button class="btn btn-outline-success my-2 my-sm-0" type="submit" style="margin-right: 15px">Vyhledat</button>
            }
        </div>
        <label for="submit-button"></label>

        <table class="table">
            <thead class="thead-dark">
                <tr>
                    <th scope="col">Článek</th>
                    <th scope="col">Autor článku</th>
                    <th scope="col">Test</th>
                </tr>
            </thead>

            <tbody>
                @foreach (TestArticle b in Model)
                {
                    <tr>
                        <td>@Ajax.ActionLink(b.Article.Name, "Detail", new { id = b.Article.Id }, new AjaxOptions() { UpdateTargetId = "dynamicContent", InsertionMode = InsertionMode.Replace })</td>
                        <td>@b.Article.Author</td>
                        @if (b.Article.TestId != 0 && b.Test.Published)
                        {
                            <td>@Ajax.ActionLink("Test", "Index", "Test", new { id = b.Article.TestId }, new AjaxOptions() { UpdateTargetId = "dynamicContent", InsertionMode = InsertionMode.Replace })</td>
                        }
                        else
                        {
                            <td>Není</td>
                        }
                    </tr>
                }
            </tbody>
        </table>
    </div>
</div>

<script>
    $(function () {
            $("#searchBox").autocomplete({
                source: function (request, response) {
                    $.ajax({
                        url:'@Url.Action("SearchArticles", "Text")',
                        dataType: "json",
                        data: {
                            query: request.term
                        },
                        success: function (data) {
                            response(data);
                        }
                    });
                },
                minLength: 2
            });
    });
</script>